<?php
#
# Solicitud de renovacion de certificados. Si los datos introducidos por 
# el usuario y los de su certificado son correctos, se enviara una solicitud
# de renovacion de dicho certificado.
#

include '../core.php';

session_start();

cabecera (1);

// El siguiente script se encarga de comprobar que los datos
// de un formulario son validos antes de enviarlos.
echo "<script type='text/javascript'>
<!--
function submit_form()
{
  if ( document.crt_renew_form.crtID.value == ''  ||
       document.crt_renew_form.crtID.value.search(/[^a-z,A-Z,0-9,\.,_,\@,\-]/i) >= 0)
  {
    alert ('Por favor introduzca un Identificador correcto. Solo puede escribir caracteres de la \'a\' a la \'z\', números y signos \'.\', \'-\' y \'_\'');
    document.crt_renew_form.crtID.focus();
    return false;
  }
  if (document.crt_renew_form.userPin.value == '')
  {
    alert ('Por favor introduzca el PIN');
    document.crt_renew_form.userPin.focus();
    return false;
  }
  document.crt_renew_form.submit();
  return true;
}
// -->
</script>\n";

// En la variable command guardaremos el estado de la renovacion.
// Dependiendo de su valor, entraremos en una u otra parte del codigo.
$command = $_POST["crt_command"];

switch($command) {
	
   // Por defecto mostramos el formulario en el que se le solicita
   // al usuario los datos del certificado a renovar   
   default:
      echo "<h1>Solicitud de Renovaci&oacute;n de Certificado</h1>
      <div id='tbox'>
         <h3 class='head_a2b1'>Datos de la Solicitud</h3>
            <div id='tbox_data_a1'>
               <form method='post' action='crt_renew.php' enctype='multipart/form-data' name='crt_renew_form'>
               <div id='trow'>
                  <div id='tname'>Identificador</div>
		  <div id='tvalue'><input class='form_input' type='text' name='crtID'  size='25' /></div>
               </div>
               <div id='trow'>
                  <div id='tname'>C&oacute;digo de solicitud</div>
		  <div id='tvalue'><input class='cajaTexto' type='text' name='copa'  size='16' /></div>
               </div>
               <div id='trow'>
                  <div id='tname'>Password de Usuario</div>
		  <div id='tvalue'><input class='cajaTexto' type='password' name='userPass'  size='16' /></div>
               </div>
               <div id='trow'>
                  <div id='tname'>PIN del Certificado</div>
		  <div id='tvalue'><input class='cajaTexto' type='password' name='userPin'  size='16' /></div>
               </div>
               <div id='trow'>
                  <div id='tname'>Privacidad</div>
		  <div id='tvalue'>Desea <a href=help.php#show_mail'>incluir su email en el certificado</a>
                     <input type='radio' name='csr_showMail'  value='FALSE' checked> No
                     <input type='radio' name='csr_showMail'  value='TRUE'> Si
		  </div>
               </div>
	       <div id='trow'>
	          <div id='tvalue'><input class='button' type='button' value='Continuar' onclick='submit_form()' /></div>
               <input type='hidden' name='crt_command' value='crt_process'>
               </form>
            </div> <!-- tbox_data_a1 -->
	 </div> <!-- tbox -->\n";
      break;

   case "crt_process":
	   
      $errorNumber = 0;
     
      // Antes de nada, tenemos que comprobar si el certificado	pertenece
      // a la RA desde la que se esta realizando la solicitud
      list ($crtNumRa, $kk) = split ("b", $copa);
      if ( $crtNumRa != $raNum ){
	 echo "<h1>Error de Solicitud de Renovaci&oacute;n </h1>
         <p>El c&oacute;digo que ha introducido no se corresponde con esta Autoridad de Registro ($raName). Debe solicitar la renovaci&oacute;n en la misma RA en la que realiz&oacute; la petici&oacute;n de su certificado</>";
	 $errorNumber = 69;
      }

      else {
	            
         $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$copa))";
         $justthese = array("pkirisID", "pkirisstatus");
         $result = ldap_get_info($base, $filter, $justthese);
         // Verificamos si existe el codigo del certificado, si el resultado 
	 // del count($result) es 1 no existe, si es 2 si existe.
         if (count($result) == 1) {
            echo "<h1>Error de Solicitud de Renovaci&oacute;n </h1>
            <p>El c&oacute;digo que ha introducido no se corresponde con ning&uacute;n certificado.</>";
	    $errorNumber = 69;
         }
	 else if ($result[0]["pkirisstatus"][0] != "issued"){
	    echo "<h1>Error de Solicitud de Renovaci&oacute;n </h1>
            <p>El c&oacute;digo que ha introducido no no se corresponde con ning&uacute;n certificado firmado. Por tanto no puede pedir una renovaci&oacute;n</>";
	    $errorNumber = 69;
	 }
         // Si existe, tenemos que comprobar si el identificador introducido 
	 // se corresponde con ese codigo
         else {  
	    if ($result[0]["pkirisid"][0] != $crtID ) {
	       echo "<h1>Error de Solicitud de Renovaci&oacute;n</h1>
	       <p>El c&oacute;digo de solicitud que ha introducido no tiene ese identificador asociado. Por tanto no puede pedir una renovaci&oacute;n</>";
	       $errorNumber = 69;
	    }

	    else {
               // Hacemos un bind al ldap para verificar la password del usuario.
               $ds = ldap_connect($ldapServer, $ldapServerPort) or die("Could not connect to $ldapServer");
         
               if ($ds) {
 	          list ($copaUsr, $kk) = split ("c", $copa);
                  $dn = $rdn1."=".$copaUsr.",".$base;
                  $ldapbind = ldap_bind($ds, $dn, $userPass);
   
           	  if (!$ldapbind) {
                     print "Password incorrecta, por favor intentelo nuevamente.";
	          }
                  else {
	          
                     // Buscamos la informacion del certificado que tenga el 
		     // usuario en estado issued.
                     $filter = "(&(objectClass=pkirisCertificate)(pkirisStatus=issued)(pkirisCopaID=$copaUsr*))";
                     $justthese = array("pkirispin", "pkiriscertificateexpirationdate");
  
                     $result = ldap_get_info($base, $filter, $justthese);

		     //Contamos cuantos certificados tiene firmados el usuario	
		     $counter = count($result);	 

		     if ($counter <= 1) {
                        echo "<h1>Error de Solicitud de Renovaci&oacute;n</h1>
                        <p>El identificador que ha introducido no tiene ning&uacute;n certifiado firmado. Por tanto no puede pedir una renovaci&oacute;n</>";
			$errorNumber = 69;
                     }
		     else if ($counter > 2) {
		        echo "<h1>Error de Solicitud de Renovaci&oacute;n</h1>
		           <p>El certificado cuyo identificador ha introducido ya tiene una renovaci&oacute;n firmada. Por lo tanto no puede solicitar otra</>";
			$errorNumber = 69;
		     }
		     // Si solo tiene un certificado firmado ($counter==2),
		     // entonces puede pedir la renovacion
		     else{		  
                       // Comparamos los pines para ver si son iguales
                       if (crypt($userPin, $result[0]["pkirispin"][0]) != $result[0]["pkirispin"][0]) {
                       echo "El pin de certificado no es v&aacute;lido.";
                       }
                       else {
                         // Obtenemos el numero de renovaciones que ha 
			 // realizado el usuario cuyo numero copa es &copaUsr			       
		         $currentRenewalsNum = renewalsCounter($copaUsr);
			 // No se le permitira renovar si ha alcanzado el numero
			 // maximo de renovaciones permitidas
			 if ($currentRenewalsNum >= $maxRenewalsNum) {
			   $errorNumber = 69;
			   echo "<h1>Error de Solicitud de Renovaci&oacute;n</h1>
			   <p>Ya ha realizado el n&uacute;mero m&aacute;ximo de renovaciones permitidas. Debe solicitar un certificado nuevo</>";
			   $errorNumber = 69;
		         }
			 else{	                   
	   		   // Recuperamos del ldap la fecha de expiracion del 
			   // certificado. Ademas, tenemos que obtener la 
			   // fecha actual y la fecha permitida para la 
			   // renovacion, correspondiente a 30 dias antes de
		       	   // la fecha de expiracion
			   $expirationDate = $result [0]["pkiriscertificateexpirationdate"][0];
			   $currentDate = date("YmdHis");
			  
			   // Pasamos la fecha de expiracion a segundos 
			   $year = substr($expirationDate, 0, 4);
			   $month = substr($expirationDate, 4, 2);
			   $day = substr($expirationDate, 6, 2);
			   $hour = substr($expirationDate, 8, 2);
			   $minute = substr($expirationDate, 10, 2);
			   $second = substr($expirationDate, 12, 2);
			   $renewalPermittedDate = mktime($hour, $minute, $second, $month, $day, $year);
                           // y le restamos 30 dias (2592000 segundos)
			   $renewalPermittedDate -= 2592000;
			   // obteniendo asi la fecha permitida
			   $renewalPermittedDate = date("YmdHis",$renewalPermittedDate);

			   // Solo podremos renovar el certificado si estamos
		           // dentro de los 30 dias permitidos			
			   if ( ($currentDate > $renewalPermittedDate) and ( $currentDate < $expirationDate) ) {
			      
			      // Comprobamos que no hay ninguna peticion de
			      // renovacion anterior
			      $copaLastCsr = $copaUsr . "c". (getCounter($copaUsr));
			      $lastStatus = getStatus($copaLastCsr);
			      
			      if ($lastStatus != "renew") {
			         // Construimos el numero copa de la nueva CSR a
                                 // partir del contador de certificados del usuario
	   		         $copaNew = $copaUsr . "c". (getCounter($copaUsr) + 1);
			   
			         $justthese = array ("pkirisid","pkirispin","pkiriscsr","pkiriscerttype","pkirissubjectdn");
			         $oldCrtInfo = ldap_get_info($base, $filter, $justthese);
			
			         // Preparamos los datos necesarios para generar la traza
		                 $status = "renew";
		                 $dn = $rdn1."=".$copaNew.",".$base;
			         $crt_type = $oldCrtInfo[0]["pkiriscerttype"][0];

		                 $traceVals["status"] = $status;
		                 $traceVals["copa"] = $copaNew;
 		                 $traceVals["currentDate"] = $currentDate;

	                         // Generamos la traza con los valores de $traceVals
 		                 $pkiTrace = getTrace($traceVals);
			      
	   		         // Creamos un array con los atributos necesarios,
			         // algunos de los cuales se copiaran del 
			         // certificado a renovar y otros seran nuevos			   
                                 $info["objectClass"][0] = "top";
		                 $info["objectClass"][1] = "irisObject";
		                 $info["objectClass"][2] = "pkirisCertificate";
			         $info[$rdn1] = "$copaNew";
			         $info["pkirisID"] = $oldCrtInfo[0]["pkirisid"][0];
		                 $info["pkirisTrace"] = $pkiTrace;
			         $info["pkirisStatus"] = $status;
                                 $info["pkirisDate"] = "$currentDate"; 
			         $info["pkirisPin"] = $oldCrtInfo[0]["pkirispin"][0];
			         $info["pkirisCSR"] = $oldCrtInfo[0]["pkiriscsr"][0];
		                 $info["pkirisCertType"] = $crt_type;
			         $info["pkirisSubjectDN"] = $oldCrtInfo[0]["pkirissubjectdn"][0];
                                 $info["pkirisCopaID"] = "$copaNew";
                                 
				 // Sacamos el email de los datos del usuario
                                 $filter = "(&(objectClass=pkirisEndEntity)(pkirisCopaID=$copaUsr))";
                                 $justthese = array("mail");
                                 $userInfo = ldap_get_info($base, $filter, $justthese);
				 $info["mail"]= $userInfo[0]["mail"][0];

				 // Si la CSR es de usuario, le agregamos 
				 // el campo pkirisShowMail
				 if( ($crt_type == "usr")  ) 
				    $info["pkirisshowmail"] = $csr_showMail;
				  
			         // Insertamos en el ldap la peticion de renovacion 
			         $r=ldap_add_info($dn, $info);			   
			         if (!$r){
		                    $errorNumber = 69;
  	                         }

				 if ($errorNumber == 0) {
  			            // Incrementamos el contador del numero de certificados del usuario
		                    $r = incrCounter ($copaUsr);

		                    if (!$r){
		                       $errorNumber = 69;
	                            }
			         
				    if ($errorNumber == 0) {
			               // Le enviamos al administrador un email para avisarle de que tiene una nueva CSR
 		                       $envioMail = mail($admRaMail, "Renovación de certificado", "Se ha generado una petición de renovación del certificado cuyo identificador es: $crtID\n");

			               echo "<h2> Solicitud Aceptada </h2>
		                       <p> Su solicitud: </p>
		                       <ul>
		                       <li> Identificador: $crtID </li>
  		                       <li> C&oacute;digo de soliciud: $copaNew </li>
		                       </ul>
		                       <p> ha sido aceptada. </p>
		                       <p> Por favor es muy importante que anote los valores anteriores ya que le serán de utilidad a la hora de las siguientes operaciones:</p>
		                       <ul>
		                       <li> Autenticación frente a la autoridad de registro. </li>
		                       <li> Descarga de su certificado. </li>
		                       <li> Revocaci&oacute;n de su certificado. </li>
		                       </ul>\n";							      				       
		   	            }
				    else {
                                       echo "<h1>Error de Solicitud de Renovaci&oacute;n</h1>";
				       $errorNumber = 69;
				    }
				 }
		                 else {
                                    echo "<h1>Error de Solicitud de Renovaci&oacute;n</h1>";
				    $errorNumber = 69;
				 }
	                      }			    
			      else {				 
				 echo "<h1>Error de Solicitud de Renovaci&oacute;n</h1>
				 <p>Ya ha realizado una solicitud de renovaci&oacute;n anteriormente y no puede solicitar una nueva hasta que no le sea aprobada o rechazada la primera. </p>";
				 $errorNumber = 69;
		              }
			   }

			   else{ // Si no estamos en el rango permitido
			      if ($currentDate <= $renewalPermittedDate ) {
			         echo "<h1>Error de Solicitud de Renovaci&oacute;n</h1>
			         <p>A&uacute;n no puede pedir una renovaci&oacute;n. Deber&aacute; solicitarla 30 d&iacute;as antes de que expire el certificado</>";
				 $errorNumber = 69;
			      }
			      else {
			         echo "<h1>Error de Solicitud de Renovaci&oacute;n</h1>
		                 <p>Su certificado ya ha expirado, por lo que no puede pedir una renovaci&oacute;n. Deber&iacute;a haberla solicitado 30 d&iacute;as antes de la fecha de expiraci&oacute;n del mismo</>";
				 $errorNumber = 69;
			      }	   		 
			   }  
			 }  
		       }
		     }
		  }
	       }
	    }
         }
      }	
      // Registramos la accion en el fichero de log
      $status = "renew";
      $user = "Publico";
      writeLog ($status, $copa, $user, $errorNumber);
      
      break;
}

pie ();

?>
